#include "dialog.h"
#include "ui_dialog.h"

#include <QTextStream>
#include <QTextEdit>
#include <QtDebug>
#include <QMessageBox>
#include <QtNetwork>
#include <QPrintDialog>
 #include <QPrinter>

// Spy vs Spy stuff
#define BEGIN_CALLSIGN  "begin calldata"
#define END_CALLSIGN	">Email: "
#define NOT_FOUND       "<div style=\"margin:1em\">"
#define END_NOT_FOUND   "<span style="


Dialog::Dialog(QWidget *parent)
    : QDialog(parent), ui(new Ui::Dialog)
{
    ui->setupUi(this);
    ui->callsign_LE->setFocus();
}
/*-----------------------------------------------------------------------------*/

Dialog::~Dialog()
{
    delete ui;
}
/*-----------------------------------------------------------------------------*/

void Dialog::on_clear_callsign_PB_clicked()
{
    ui->callsign_LE->setText("");    
    ui->result_TE->clear();
    ui->callsign_LE->setFocus();
}
/*-----------------------------------------------------------------------------*/

void Dialog::on_search_PB_clicked()
{
    getit();
}
/*-----------------------------------------------------------------------------*/

void Dialog::parseit(){   
QTextStream stream(http->readAll());
flag = FALSE;
str = "";
 while(!stream.atEnd()){  
    lineOdata = stream.readLine();
    // Read in one line of text at a time
    if (lineOdata.contains(NOT_FOUND)){
        // A text string was found that indicates the callsign not in database
        flag = TRUE;
        ui->result_TE->setText(tr("...Callsign not found..."));
        }
    if ( flag && (lineOdata.contains(END_NOT_FOUND))) {
        // The last part of the text we want is done so stop looking at any more text
        flag = FALSE;
        }
    if (lineOdata.contains(BEGIN_CALLSIGN)) {
        // Found the callsign in the database
                flag = TRUE;             
        }
    if ( flag && (lineOdata.contains(END_CALLSIGN))) {
        // The last part of the text we want is done so stop looking at any more text
        flag = FALSE;
        }
    if (flag && (lineOdata.contains("<img src="))){
        // Erase lines referencing image data (for now)
        lineOdata = "";
        }
    // Save the line if its good
    if (flag) {
        //qDebug() << lineOdata; // DEBUG: Make sure what is saved is good data
        str = str + lineOdata;
        }
    }
 ui->result_TE->setText(str); // Print result to main window
 ui->callsign_LE->setText(callsign);
}
 /*-----------------------------------------------------------------------------*/

void Dialog::getit()
{    
    website = "www.qrz.com";
    callsign = ui->callsign_LE->text().toUpper();
    ui->callsign_LE->setText(callsign);
    gohere = "/callsign/" + callsign;
    if (ui->callsign_LE->text() == "") {
        QMessageBox::critical(this,tr( "Empty query"),
                              tr("Please type a callsign."),
                              QMessageBox::Ok, QMessageBox::NoButton);
    }else{
            ui->result_TE->setText("...Getting html...");
            http = new QHttp(this);
            connect(http, SIGNAL(done(bool)), this, SLOT(httpDone(bool)));
            http->setHost(website);
            http->get(gohere);
            }
}
/*-----------------------------------------------------------------------------*/

void Dialog::httpDone(bool error){
    if (error){
        ui->result_TE->clear();
        QMessageBox::warning(this, tr("HTTP Get"),
                         tr("Error while fetching file with HTTP: %1")
                         .arg(http->errorString()));
        }
    parseit();
}
/*-----------------------------------------------------------------------------*/

void Dialog::on_saveit_PB_clicked()
{
    ui->result_TE->selectAll();
    ui->result_TE->copy();
    ui->saved_TE->paste();
}
/*-----------------------------------------------------------------------------*/

void Dialog::on_callsign_LE_returnPressed()
{
     getit();
}
/*-----------------------------------------------------------------------------*/
